package com.github.gkutiel.filter;

import static com.github.gkutiel.filter.Injector.newInjector;
import static com.github.gkutiel.filter.Invoker.invoke;

import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.github.gkutiel.filter.Filter.RedirectException;

class FilterHandler extends HttpServlet {
	private final Class<? extends Filter> filter;

	public FilterHandler(final Class<? extends Filter> filter) {
		this.filter = filter;
	}

	@Override
	protected void doGet(final HttpServletRequest req, final HttpServletResponse res) throws ServletException, IOException {
		try {
			invoke(new FilterChainBuilder(newInjector(req, res)).build(filter));
		} catch (final RedirectException e) {}
	}

	@Override
	protected void doPost(final HttpServletRequest req, final HttpServletResponse res) throws ServletException, IOException {
		doGet(req, res);
	}
}