package com.github.gkutiel.filter;

import org.eclipse.jetty.server.Server;
import org.eclipse.jetty.server.handler.HandlerList;
import org.eclipse.jetty.servlet.ServletHandler;
import org.eclipse.jetty.servlet.ServletHolder;

public class FilterServer {
	private final HandlerList handlers = new HandlerList();
	private final ServletHandler servletHandler = new ServletHandler();

	private final Server server;

	public FilterServer(final int port) {
		server = new Server(port);
		handlers.addHandler(new ResourceHandler());
		handlers.addHandler(servletHandler);
		server.setHandler(handlers);
	}

	public FilterServer map(final String path, final Class<? extends Filter> filter) {
		servletHandler.addServletWithMapping(new ServletHolder(new FilterHandler(filter) {}), path);
		return this;
	}

	public <T extends Api> FilterServer map(final String path, final Class<? extends Remote<T>> ws, final Class<T> remote) {
		servletHandler.addServletWithMapping(new ServletHolder(new WebSocketHandler<>(ws, remote)), path);
		return this;
	}

	public void start() {
		try {
			server.start();
			server.join();
		} catch (final Exception e) {
			throw new RuntimeException(e);
		}
	}
}
